Fix indent bug.
[gnutls.git] / maint.mk
blob6942730b7640c575202bd9d0fd2af2db4c03e20b
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
5 ## Copyright (C) 2001-2010 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
24 # Override this in cfg.mk if you use a non-standard build-aux directory.
25 build_aux ?= $(srcdir)/build-aux
27 # Do not save the original name or timestamp in the .tar.gz file.
28 # Use --rsyncable if available.
29 gzip_rsyncable := \
30 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null && echo --rsyncable)
31 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
33 GIT = git
34 VC = $(GIT)
35 VC-tag = git tag -s -m '$(VERSION)' -u '$(gpg_key_ID)'
37 VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
39 # You can override this variable in cfg.mk to set your own regexp
40 # matching files to ignore.
41 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
43 # This is to preprocess robustly the output of $(VC_LIST), so that even
44 # when $(srcdir) is a pathological name like "....", the leading sed command
45 # removes only the intended prefix.
46 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
48 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
49 # when $(srcdir) is not ".".
50 ifeq ($(srcdir),.)
51 _prepend_srcdir_prefix =
52 else
53 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
54 endif
56 # In order to be able to consistently filter "."-relative names,
57 # (i.e., with no $(srcdir) prefix), this definition is careful to
58 # remove any $(srcdir) prefix, and to restore what it removes.
59 VC_LIST_EXCEPT = \
60 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
61 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
62 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
63 | grep -Ev -e '$(VC_LIST_ALWAYS_EXCLUDE_REGEX)' \
64 $(_prepend_srcdir_prefix)
66 ifeq ($(origin prev_version_file), undefined)
67 prev_version_file = $(srcdir)/.prev-version
68 endif
70 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
71 VERSION_REGEXP = $(subst .,\.,$(VERSION))
72 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
74 ifeq ($(VC),$(GIT))
75 this-vc-tag = v$(VERSION)
76 this-vc-tag-regexp = v$(VERSION_REGEXP)
77 else
78 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
79 tag-this-version = $(subst .,_,$(VERSION))
80 this-vc-tag = $(tag-package)-$(tag-this-version)
81 this-vc-tag-regexp = $(this-vc-tag)
82 endif
83 my_distdir = $(PACKAGE)-$(VERSION)
85 # Old releases are stored here.
86 release_archive_dir ?= ../release
88 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
89 # Use alpha.gnu.org for alpha and beta releases.
90 # Use ftp.gnu.org for stable releases.
91 gnu_ftp_host-alpha = alpha.gnu.org
92 gnu_ftp_host-beta = alpha.gnu.org
93 gnu_ftp_host-stable = ftp.gnu.org
94 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
96 ifeq ($(gnu_rel_host),ftp.gnu.org)
97 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
98 else
99 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
100 endif
102 # Override this in cfg.mk if you are using a different format in your
103 # NEWS file.
104 today = $(shell date +%Y-%m-%d)
105 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
107 # Prevent programs like 'sort' from considering distinct strings to be equal.
108 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
109 export LC_ALL = C
111 ## --------------- ##
112 ## Sanity checks. ##
113 ## --------------- ##
115 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
117 # Collect the names of rules starting with `sc_'.
118 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
119 $(srcdir)/$(ME) $(_cfg_mk)))
120 .PHONY: $(syntax-check-rules)
122 local-checks-available = \
123 $(syntax-check-rules)
124 .PHONY: $(local-checks-available)
126 # Arrange to print the name of each syntax-checking rule just before running it.
127 $(syntax-check-rules): %: %.m
128 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
129 .PHONY: $(sc_m_rules_)
130 $(sc_m_rules_):
131 @echo $(patsubst sc_%.m, %, $@)
132 @date +%s.%N > .sc-start-$(basename $@)
134 # Compute and print the elapsed time for each syntax-check rule.
135 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
136 .PHONY: $(sc_z_rules_)
137 $(sc_z_rules_): %.z: %
138 @end=$$(date +%s.%N); \
139 start=$$(cat .sc-start-$*); \
140 rm -f .sc-start-$*; \
141 awk -v s=$$start -v e=$$end \
142 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
144 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
145 # that computes and prints elapsed time.
146 local-check := \
147 $(patsubst sc_%, sc_%.z, \
148 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
150 syntax-check: $(local-check)
151 # @grep -nE '# *include <(limits|std(def|arg|bool))\.h>' \
152 # $$(find -type f -name '*.[chly]') && \
153 # { echo '$(ME): found conditional include' 1>&2; \
154 # exit 1; } || :
156 # grep -nE '^# *include <(string|stdlib)\.h>' \
157 # $(srcdir)/{lib,src}/*.[chy] && \
158 # { echo '$(ME): FIXME' 1>&2; \
159 # exit 1; } || :
160 # FIXME: don't allow `#include .strings\.h' anywhere
162 # _sc_search_regexp
164 # This macro searches for a given construct in the selected files and
165 # then takes some action.
167 # Parameters (shell variables):
169 # prohibit | require
171 # Regular expression (ERE) denoting either a forbidden construct
172 # or a required construct. Those arguments are exclusive.
174 # in_vc_files | in_files
176 # grep-E-style regexp denoting the files to check. If no files
177 # are specified the default are all the files that are under
178 # version control.
180 # containing | non_containing
182 # Select the files (non) containing strings matching this regexp.
183 # If both arguments are specified then CONTAINING takes
184 # precedence.
186 # with_grep_options
188 # Extra options for grep.
190 # ignore_case
192 # Ignore case.
194 # halt
196 # Message to display before to halting execution.
198 # By default, _sc_search_regexp does not ignore case.
199 export ignore_case =
200 _ignore_case = $$(test -n "$$ignore_case" && echo -i || :)
202 define _sc_say_and_exit
203 dummy=; : so we do not need a semicolon before each use; \
204 { echo -e "$(ME): $$msg" 1>&2; exit 1; };
205 endef
207 # _sc_search_regexp used to be named _prohibit_regexp. However,
208 # upgrading to the new definition and leaving the old name undefined
209 # would usually convert each custom rule using $(_prohibit_regexp)
210 # (usually defined in cfg.mk) into a no-op. This definition ensures
211 # that people know right away if they're still using the old name.
212 # FIXME: remove in 2012.
213 _prohibit_regexp = \
214 $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
216 define _sc_search_regexp
217 dummy=; : so we do not need a semicolon before each use; \
219 : Check arguments; \
220 test -n "$$prohibit" && test -n "$$require" \
221 && { msg='Cannot specify both prohibit and require' \
222 $(_sc_say_and_exit) } || :; \
223 test -z "$$prohibit" && test -z "$$require" \
224 && { msg='Should specify either prohibit or require' \
225 $(_sc_say_and_exit) } || :; \
226 test -n "$$in_vc_files" && test -n "$$in_files" \
227 && { msg='Cannot specify both in_vc_files and in_files' \
228 $(_sc_say_and_exit) } || :; \
229 test "x$$halt" != x \
230 || { msg='halt not defined' $(_sc_say_and_exit) }; \
232 : Filter by file name; \
233 if test -n "$$in_files"; then \
234 files=$$(find $(srcdir) | grep -E "$$in_files"); \
235 else \
236 files=$$($(VC_LIST_EXCEPT)); \
237 if test -n "$$in_vc_files"; then \
238 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
239 fi; \
240 fi; \
242 : Filter by content; \
243 test -n "$$files" && test -n "$$containing" \
244 && { files=$$(grep -l "$$containing" $$files); } || :; \
245 test -n "$$files" && test -n "$$non_containing" \
246 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
248 : Check for the construct; \
249 if test -n "$$files"; then \
250 if test -n "$$prohibit"; then \
251 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
252 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
253 else \
254 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
255 | grep . \
256 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
257 fi \
258 else :; \
259 fi || :;
260 endef
262 sc_avoid_if_before_free:
263 @$(build_aux)/useless-if-before-free \
264 $(useless_free_options) \
265 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
266 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
267 exit 1; } || :
269 sc_cast_of_argument_to_free:
270 @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
271 $(_sc_search_regexp)
273 sc_cast_of_x_alloc_return_value:
274 @prohibit='\*\) *x(m|c|re)alloc\>' \
275 halt='don'\''t cast x*alloc return value' \
276 $(_sc_search_regexp)
278 sc_cast_of_alloca_return_value:
279 @prohibit='\*\) *alloca\>' \
280 halt='don'\''t cast alloca return value' \
281 $(_sc_search_regexp)
283 sc_space_tab:
284 @prohibit='[ ] ' \
285 halt='found SPACE-TAB sequence; remove the SPACE' \
286 $(_sc_search_regexp)
288 # Don't use *scanf or the old ato* functions in `real' code.
289 # They provide no error checking mechanism.
290 # Instead, use strto* functions.
291 sc_prohibit_atoi_atof:
292 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
293 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
294 $(_sc_search_regexp)
296 # Use STREQ rather than comparing strcmp == 0, or != 0.
297 sc_prohibit_strcmp:
298 @grep -nE '! *str''cmp *\(|\<str''cmp *\([^)]+\) *==' \
299 $$($(VC_LIST_EXCEPT)) \
300 | grep -vE ':# *define STREQ\(' && \
301 { echo '$(ME): use STREQ in place of the above uses of str''cmp' \
302 1>&2; exit 1; } || :
304 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
305 # Convert all uses automatically, via these two commands:
306 # git grep -l '\<exit *(1)' \
307 # | grep -vEf .x-sc_prohibit_magic_number_exit \
308 # | xargs --no-run-if-empty \
309 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
310 # git grep -l '\<exit *(0)' \
311 # | grep -vEf .x-sc_prohibit_magic_number_exit \
312 # | xargs --no-run-if-empty \
313 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
314 sc_prohibit_magic_number_exit:
315 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
316 halt='use EXIT_* values rather than magic number' \
317 $(_sc_search_regexp)
319 # Using EXIT_SUCCESS as the first argument to error is misleading,
320 # since when that parameter is 0, error does not exit. Use `0' instead.
321 sc_error_exit_success:
322 @prohibit='error *\(EXIT_SUCCESS,' \
323 in_vc_files='\.[chly]$$' \
324 halt='found error (EXIT_SUCCESS' \
325 $(_sc_search_regexp)
327 # `FATAL:' should be fully upper-cased in error messages
328 # `WARNING:' should be fully upper-cased, or fully lower-cased
329 sc_error_message_warn_fatal:
330 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
331 | grep -E '"Warning|"Fatal|"fatal' && \
332 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
333 exit 1; } || :
335 # Error messages should not start with a capital letter
336 sc_error_message_uppercase:
337 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
338 | grep -E '"[A-Z]' \
339 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
340 { echo '$(ME): found capitalized error message' 1>&2; \
341 exit 1; } || :
343 # Error messages should not end with a period
344 sc_error_message_period:
345 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
346 | grep -E '[^."]\."' && \
347 { echo '$(ME): found error message ending in period' 1>&2; \
348 exit 1; } || :
350 sc_file_system:
351 @prohibit=file''system \
352 ignore_case=1 \
353 halt='found use of "file''system"; spell it "file system"' \
354 $(_sc_search_regexp)
356 # Don't use cpp tests of this symbol. All code assumes config.h is included.
357 sc_prohibit_have_config_h:
358 @prohibit='^# *if.*HAVE''_CONFIG_H' \
359 halt='found use of HAVE''_CONFIG_H; remove' \
360 $(_sc_search_regexp)
362 # Nearly all .c files must include <config.h>. However, we also permit this
363 # via inclusion of a package-specific header, if cfg.mk specified one.
364 # config_h_header must be suitable for grep -E.
365 config_h_header ?= <config\.h>
366 sc_require_config_h:
367 @require='^# *include $(config_h_header)' \
368 in_vc_files='\.c$$' \
369 halt='the above files do not include <config.h>' \
370 $(_sc_search_regexp)
372 # You must include <config.h> before including any other header file.
373 # This can possibly be via a package-specific header, if given by cfg.mk.
374 sc_require_config_h_first:
375 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
376 fail=0; \
377 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
378 grep '^# *include\>' $$i | sed 1q \
379 | grep -E '^# *include $(config_h_header)' > /dev/null \
380 || { echo $$i; fail=1; }; \
381 done; \
382 test $$fail = 1 && \
383 { echo '$(ME): the above files include some other header' \
384 'before <config.h>' 1>&2; exit 1; } || :; \
385 else :; \
388 sc_prohibit_HAVE_MBRTOWC:
389 @prohibit='\bHAVE_MBRTOWC\b' \
390 halt="do not use $$prohibit; it is always defined" \
391 $(_sc_search_regexp)
393 # To use this "command" macro, you must first define two shell variables:
394 # h: the header, enclosed in <> or ""
395 # re: a regular expression that matches IFF something provided by $h is used.
396 define _sc_header_without_use
397 dummy=; : so we do not need a semicolon before each use; \
398 h_esc=`echo "$$h"|sed 's/\./\\\\./g'`; \
399 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
400 files=$$(grep -l '^# *include '"$$h_esc" \
401 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
402 grep -LE "$$re" $$files | grep . && \
403 { echo "$(ME): the above files include $$h but don't use it" \
404 1>&2; exit 1; } || :; \
405 else :; \
407 endef
409 # Prohibit the inclusion of assert.h without an actual use of assert.
410 sc_prohibit_assert_without_use:
411 @h='<assert.h>' re='\<assert *\(' $(_sc_header_without_use)
413 # Prohibit the inclusion of close-stream.h without an actual use.
414 sc_prohibit_close_stream_without_use:
415 @h='"close-stream.h"' re='\<close_stream *\(' $(_sc_header_without_use)
417 # Prohibit the inclusion of getopt.h without an actual use.
418 sc_prohibit_getopt_without_use:
419 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
421 # Don't include quotearg.h unless you use one of its functions.
422 sc_prohibit_quotearg_without_use:
423 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
425 # Don't include quote.h unless you use one of its functions.
426 sc_prohibit_quote_without_use:
427 @h='"quote.h"' re='\<quote(_n)? *\(' $(_sc_header_without_use)
429 # Don't include this header unless you use one of its functions.
430 sc_prohibit_long_options_without_use:
431 @h='"long-options.h"' re='\<parse_long_options *\(' \
432 $(_sc_header_without_use)
434 # Don't include this header unless you use one of its functions.
435 sc_prohibit_inttostr_without_use:
436 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
437 $(_sc_header_without_use)
439 # Don't include this header unless you use one of its functions.
440 sc_prohibit_ignore_value_without_use:
441 @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \
442 $(_sc_header_without_use)
444 # Don't include this header unless you use one of its functions.
445 sc_prohibit_error_without_use:
446 @h='"error.h"' \
447 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
448 $(_sc_header_without_use)
450 # Don't include xalloc.h unless you use one of its functions.
451 # Consider these symbols:
452 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
453 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
454 # Divide into two sets on case, and filter each through this:
455 # | sort | perl -MRegexp::Assemble -le \
456 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
457 # Note this was produced by the above:
458 # _xa1 = \
459 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
460 # But we can do better, in at least two ways:
461 # 1) take advantage of two "dup"-suffixed strings:
462 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
463 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
464 # "char|[cmz]"
465 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
466 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
467 _xa2 = X([CZ]|N?M)ALLOC
468 sc_prohibit_xalloc_without_use:
469 @h='"xalloc.h"' \
470 re='\<($(_xa1)|$(_xa2)) *\('\
471 $(_sc_header_without_use)
473 # Extract function names:
474 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
475 _hash_re = \
476 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
477 _hash_fn = \<($(_hash_re)) *\(
478 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
479 sc_prohibit_hash_without_use:
480 @h='"hash.h"' \
481 re='$(_hash_fn)|$(_hash_struct)'\
482 $(_sc_header_without_use)
484 sc_prohibit_hash_pjw_without_use:
485 @h='"hash-pjw.h"' \
486 re='\<hash_pjw *\(' \
487 $(_sc_header_without_use)
489 sc_prohibit_safe_read_without_use:
490 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
491 $(_sc_header_without_use)
493 sc_prohibit_argmatch_without_use:
494 @h='"argmatch.h"' \
495 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
496 $(_sc_header_without_use)
498 sc_prohibit_canonicalize_without_use:
499 @h='"canonicalize.h"' \
500 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
501 $(_sc_header_without_use)
503 sc_prohibit_root_dev_ino_without_use:
504 @h='"root-dev-ino.h"' \
505 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
506 $(_sc_header_without_use)
508 sc_prohibit_openat_without_use:
509 @h='"openat.h"' \
510 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
511 $(_sc_header_without_use)
513 # Prohibit the inclusion of c-ctype.h without an actual use.
514 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
515 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
516 sc_prohibit_c_ctype_without_use:
517 @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' \
518 $(_sc_header_without_use)
520 _empty =
521 _sp = $(_empty) $(_empty)
522 # The following list was generated by running:
523 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
524 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
525 _sig_functions = \
526 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
527 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
528 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
529 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
530 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
531 # The following were extracted from "man signal.h" manually.
532 _sig_types_and_consts = \
533 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
534 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
535 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
536 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
537 sigstack sigval stack_t ucontext_t
538 # generated via this:
539 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
540 _sig_names = \
541 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
542 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
543 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
544 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
545 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
546 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
547 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
548 SIGXCPU SIGXFSZ
549 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
551 # Prohibit the inclusion of signal.h without an actual use.
552 sc_prohibit_signal_without_use:
553 @h='<signal.h>' \
554 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
555 $(_sc_header_without_use)
557 # Get the list of symbol names with this:
558 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/intprops.h|grep -v '^s'|fmt
559 _intprops_names = \
560 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
561 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
562 INT_STRLEN_BOUND INT_BUFSIZE_BOUND
563 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
564 # Prohibit the inclusion of intprops.h without an actual use.
565 sc_prohibit_intprops_without_use:
566 @h='"intprops.h"' \
567 re='\<($(_intprops_syms_re)) *\(' \
568 $(_sc_header_without_use)
570 sc_obsolete_symbols:
571 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
572 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
573 $(_sc_search_regexp)
575 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
577 # Each nonempty ChangeLog line must start with a year number, or a TAB.
578 sc_changelog:
579 @prohibit='^[^12 ]' \
580 in_vc_files='^ChangeLog$$' \
581 halt='found unexpected prefix in a ChangeLog' \
582 $(_sc_search_regexp)
584 # Ensure that each .c file containing a "main" function also
585 # calls set_program_name.
586 sc_program_name:
587 @require='set_program_name *\(m?argv\[0\]\);' \
588 in_vc_files='\.c$$' \
589 containing='^main *(' \
590 halt='the above files do not call set_program_name' \
591 $(_sc_search_regexp)
593 # Require that the final line of each test-lib.sh-using test be this one:
594 # Exit $fail
595 # Note: this test requires GNU grep's --label= option.
596 Exit_witness_file ?= tests/test-lib.sh
597 Exit_base := $(notdir $(Exit_witness_file))
598 sc_require_test_exit_idiom:
599 @if test -f $(srcdir)/$(Exit_witness_file); then \
600 die=0; \
601 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
602 $$($(VC_LIST) tests)); do \
603 tail -n1 $$i | grep '^Exit .' > /dev/null \
604 && : || { die=1; echo $$i; } \
605 done; \
606 test $$die = 1 && \
607 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
608 echo 1>&2 'Exit something'; \
609 exit 1; } || :; \
612 sc_the_the:
613 @prohibit='\<the ''the\>' \
614 ignore_case=1 \
615 halt='found use of "the ''the";' \
616 $(_sc_search_regexp)
618 sc_trailing_blank:
619 @prohibit='[ ]$$' \
620 halt='found trailing blank(s)' \
621 $(_sc_search_regexp)
623 # Match lines like the following, but where there is only one space
624 # between the options and the description:
625 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
626 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
627 sc_two_space_separator_in_usage:
628 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
629 halt='help2man requires at least two spaces between an option and its description'\
630 $(_sc_search_regexp)
632 # Look for diagnostics that aren't marked for translation.
633 # This won't find any for which error's format string is on a separate line.
634 sc_unmarked_diagnostics:
635 @grep -nE \
636 '\<error *\([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \
637 | grep -v '_''(' && \
638 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
639 exit 1; } || :
641 # Avoid useless parentheses like those in this example:
642 # #if defined (SYMBOL) || defined (SYM2)
643 sc_useless_cpp_parens:
644 @prohibit='^# *if .*defined *\(' \
645 halt='found useless parentheses in cpp directive' \
646 $(_sc_search_regexp)
648 # Require the latest GPL.
649 sc_GPL_version:
650 @prohibit='either ''version [^3]' \
651 halt='GPL vN, N!=3' \
652 $(_sc_search_regexp)
654 # Require the latest GFDL. Two regexp, since some .texi files end up
655 # line wrapping between 'Free Documentation License,' and 'Version'.
656 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
657 sc_GFDL_version:
658 @prohibit='$(_GFDL_regexp)' \
659 halt='GFDL vN, N!=3' \
660 $(_sc_search_regexp)
662 # Don't use Texinfo @acronym{} as it is not a good idea.
663 sc_texinfo_acronym:
664 @prohibit='@acronym{' \
665 in_vc_files='\.texi$$' \
666 halt='found use of Texinfo @acronym{}' \
667 $(_sc_search_regexp)
669 cvs_keywords = \
670 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
672 sc_prohibit_cvs_keyword:
673 @prohibit='\$$($(cvs_keywords))\$$' \
674 halt='do not use CVS keyword expansion' \
675 $(_sc_search_regexp)
677 # This Perl code is slightly obfuscated. Not only is each "$" doubled
678 # because it's in a Makefile, but the $$c's are comments; we cannot
679 # use "#" due to the way the script ends up concatenated onto one line.
680 # It would be much more concise, and would produce better output (including
681 # counts) if written as:
682 # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
683 # but that would be far less efficient, reading the entire contents
684 # of each file, rather than just the last two bytes of each.
686 # This is a perl script that is expected to be the single-quoted argument
687 # to a command-line "-le". The remaining arguments are file names.
688 # Print the name of each file that ends in two or more newline bytes.
689 # Exit nonzero if at least one such file is found, otherwise, exit 0.
690 # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
692 # Use this if you want to remove trailing empty lines from selected files:
693 # perl -pi -0777 -e 's/\n\n+$/\n/' files...
695 detect_empty_lines_at_EOF_ = \
696 foreach my $$f (@ARGV) { \
697 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
698 my $$p = sysseek (F, -2, 2); \
699 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
700 my $$two; \
701 defined $$p and $$p = sysread F, $$two, 2; \
702 close F; \
703 $$c = "ignore read failure"; \
704 $$p && $$two eq "\n\n" and (print $$f), $$fail=1; \
705 } END { exit defined $$fail }
706 sc_prohibit_empty_lines_at_EOF:
707 @perl -le '$(detect_empty_lines_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
708 || { echo '$(ME): the above files end with empty line(s)' \
709 1>&2; exit 1; } || :; \
711 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
712 # This is a bit of a kludge, since it prevents use of the string
713 # even in comments, but for now it does the job with no false positives.
714 sc_prohibit_stat_st_blocks:
715 @prohibit='[.>]st_blocks' \
716 halt='do not use st_blocks; use ST_NBLOCKS' \
717 $(_sc_search_regexp)
719 # Make sure we don't define any S_IS* macros in src/*.c files.
720 # They're already defined via gnulib's sys/stat.h replacement.
721 sc_prohibit_S_IS_definition:
722 @prohibit='^ *# *define *S_IS' \
723 halt='do not define S_IS* macros; include <sys/stat.h>' \
724 $(_sc_search_regexp)
726 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
727 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
728 # Using test's -a and -o operators is not portable.
729 # We prefer test over [, since the latter is spelled [[ in configure.ac.
730 sc_prohibit_test_minus_ao:
731 @prohibit='(\<test| \[+) .+ -[ao] ' \
732 halt='$(_ptm1); $(_ptm2)' \
733 $(_sc_search_regexp)
735 # Each program that uses proper_name_utf8 must link with one of the
736 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
737 # The perl -0777 invocation below extracts the possibly-multi-line
738 # definition of LDADD from the appropriate Makefile.am and exits 0
739 # when it contains "ICONV".
740 sc_proper_name_utf8_requires_ICONV:
741 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
742 if test "x$$progs" != x; then \
743 fail=0; \
744 for p in $$progs; do \
745 dir=$$(dirname "$$p"); \
746 perl -0777 \
747 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
748 $$dir/Makefile.am && continue; \
749 base=$$(basename "$$p" .c); \
750 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
751 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
752 done; \
753 test $$fail = 1 && \
754 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
755 exit 1; } || :; \
758 # Warn about "c0nst struct Foo const foo[]",
759 # but not about "char const *const foo" or "#define const const".
760 sc_redundant_const:
761 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
762 halt='redundant "const" in declarations' \
763 $(_sc_search_regexp)
765 sc_const_long_option:
766 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
767 | grep -Ev 'const struct option|struct option const' && { \
768 echo 1>&2 '$(ME): add "const" to the above declarations'; \
769 exit 1; } || :
771 NEWS_hash = \
772 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
773 $(srcdir)/NEWS \
774 | perl -0777 -pe \
775 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
776 | md5sum - \
777 | sed 's/ .*//')
779 # Ensure that we don't accidentally insert an entry into an old NEWS block.
780 sc_immutable_NEWS:
781 @if test -f $(srcdir)/NEWS; then \
782 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
783 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
786 # Update the hash stored above. Do this after each release and
787 # for any corrections to old entries.
788 update-NEWS-hash: NEWS
789 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
790 $(srcdir)/cfg.mk
792 # Ensure that we use only the standard $(VAR) notation,
793 # not @...@ in Makefile.am, now that we can rely on automake
794 # to emit a definition for each substituted variable.
795 # We use perl rather than "grep -nE ..." to exempt a single
796 # use of an @...@-delimited variable name in src/Makefile.am.
797 # Allow the package to add exceptions via a hook in cfg.mk;
798 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
799 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
800 _makefile_at_at_check_exceptions ?=
801 sc_makefile_at_at_check:
802 @perl -ne '/\@[A-Z_0-9]+\@/'$(_makefile_at_at_check_exceptions) \
803 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
804 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)Makefile\.am$$') \
805 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
807 news-check: NEWS
808 if head $(srcdir)/NEWS | grep -E $(news-check-regexp) \
809 >/dev/null; then \
810 :; \
811 else \
812 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
813 exit 1; \
816 sc_makefile_TAB_only_indentation:
817 @prohibit='^ [ ]{8}' \
818 in_vc_files='akefile|\.mk$$' \
819 halt='found TAB-8-space indentation' \
820 $(_sc_search_regexp)
822 sc_m4_quote_check:
823 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
824 in_vc_files='(^configure\.ac|\.m4)$$' \
825 halt='quote the first arg to AC_DEF*' \
826 $(_sc_search_regexp)
828 fix_po_file_diag = \
829 'you have changed the set of files with translatable diagnostics;\n\
830 apply the above patch\n'
832 # Verify that all source files using _() are listed in po/POTFILES.in.
833 po_file = po/POTFILES.in
834 sc_po_check:
835 @if test -f $(po_file); then \
836 grep -E -v '^(#|$$)' $(po_file) \
837 | grep -v '^src/false\.c$$' | sort > $@-1; \
838 files=; \
839 for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do \
840 test -r $$file || continue; \
841 case $$file in \
842 *.m4|*.mk) continue ;; \
843 *.?|*.??) ;; \
844 *) continue;; \
845 esac; \
846 case $$file in \
847 *.[ch]) \
848 base=`expr " $$file" : ' \(.*\)\..'`; \
849 { test -f $$base.l || test -f $$base.y; } && continue;; \
850 esac; \
851 files="$$files $$file"; \
852 done; \
853 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
854 | sort -u > $@-2; \
855 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
856 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
857 rm -f $@-1 $@-2; \
860 # Sometimes it is useful to change the PATH environment variable
861 # in Makefiles. When doing so, it's better not to use the Unix-centric
862 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
863 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
864 sc_makefile_path_separator_check:
865 @prohibit='PATH[=].*:' \
866 in_vc_files='akefile|\.mk$$' \
867 halt=$(msg) \
868 $(_sc_search_regexp)
870 # Check that `make alpha' will not fail at the end of the process.
871 writable-files:
872 if test -d $(release_archive_dir); then :; else \
873 for file in $(distdir).tar.gz \
874 $(release_archive_dir)/$(distdir).tar.gz; do \
875 test -e $$file || continue; \
876 test -w $$file \
877 || { echo ERROR: $$file is not writable; fail=1; }; \
878 done; \
879 test "$$fail" && exit 1 || : ; \
882 v_etc_file = lib/version-etc.c
883 sample-test = tests/sample-test
884 texi = doc/$(PACKAGE).texi
885 # Make sure that the copyright date in $(v_etc_file) is up to date.
886 # Do the same for the $(sample-test) and the main doc/.texi file.
887 sc_copyright_check:
888 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
889 in_files=$(v_etc_file) \
890 halt='out of date copyright in $(v_etc_file); update it' \
891 $(_sc_search_regexp)
892 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
893 in_vc_files=$(sample-test) \
894 halt='out of date copyright in $(sample-test); update it' \
895 $(_sc_search_regexp)
896 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
897 in_vc_files=$(texi) \
898 halt='out of date copyright in $(texi); update it' \
899 $(_sc_search_regexp)
901 # If tests/help-version exists and seems to be new enough, assume that its
902 # use of init.sh and path_prepend_ is correct, and ensure that every other
903 # use of init.sh is identical.
904 # This is useful because help-version cross-checks prog --version
905 # with $(VERSION), which verifies that its path_prepend_ invocation
906 # sets PATH correctly. This is an inexpensive way to ensure that
907 # the other init.sh-using tests also get it right.
908 _hv_file ?= $(srcdir)/tests/help-version
909 _hv_regex ?= ^ *\. [^ ]*/init\.sh
910 sc_cross_check_PATH_usage_in_tests:
911 @if test -f $(_hv_file); then \
912 if grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
913 && grep -lE '$(_hv_regex)' $(_hv_file) >/dev/null; then \
914 good=$$(grep -E '$(_hv_regex)' < $(_hv_file)); \
915 grep -LFx "$$good" \
916 $$(grep -lE '$(_hv_regex)' $$($(VC_LIST_EXCEPT))) \
917 | grep . && \
918 { echo "$(ME): the above files use path_prepend_ inconsistently" \
919 1>&2; exit 1; } || :; \
920 fi; \
921 else \
922 echo "$@: skipped: no such file: $(_hv_file)"; \
925 # #if HAVE_... will evaluate to false for any non numeric string.
926 # That would be flagged by using -Wundef, however gnulib currently
927 # tests many undefined macros, and so we can't enable that option.
928 # So at least preclude common boolean strings as macro values.
929 sc_Wundef_boolean:
930 @prohibit='^#define.*(yes|no|true|false)$$' \
931 in_files='$(CONFIG_INCLUDE)' \
932 halt='Use 0 or 1 for macro values' \
933 $(_sc_search_regexp)
935 sc_vulnerable_makefile_CVE-2009-4029:
936 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
937 in_files=$$(find $(srcdir) -name Makefile.in) \
938 halt='the above files are vulnerable; beware of running\n'\
939 '"make dist*" rules, and upgrade to fixed automake\n'\
940 'see http://bugzilla.redhat.com/542609 for details' \
941 $(_sc_search_regexp)
943 vc-diff-check:
944 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
945 if test -s vc-diffs; then \
946 cat vc-diffs; \
947 echo "Some files are locally modified:" 1>&2; \
948 exit 1; \
949 else \
950 rm vc-diffs; \
953 rel-files = $(DIST_ARCHIVES)
955 gnulib_dir ?= $(srcdir)/gnulib
956 gnulib-version = $$(cd $(gnulib_dir) && git describe)
957 bootstrap-tools ?= autoconf,automake,gnulib
959 # If it's not already specified, derive the GPG key ID from
960 # the signed tag we've just applied to mark this release.
961 gpg_key_ID ?= \
962 $$(git cat-file tag v$(VERSION) > .ann-sig \
963 && gpgv .ann-sig - < /dev/null 2>&1 \
964 | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
966 announcement: NEWS ChangeLog $(rel-files)
967 @$(build_aux)/announce-gen \
968 --release-type=$(RELEASE_TYPE) \
969 --package=$(PACKAGE) \
970 --prev=$(PREV_VERSION) \
971 --curr=$(VERSION) \
972 --gpg-key-id=$(gpg_key_ID) \
973 --news=$(srcdir)/NEWS \
974 --bootstrap-tools=$(bootstrap-tools) \
975 --gnulib-version=$(gnulib-version) \
976 --no-print-checksums \
977 $(addprefix --url-dir=, $(url_dir_list))
979 ## ---------------- ##
980 ## Updating files. ##
981 ## ---------------- ##
983 ftp-gnu = ftp://ftp.gnu.org/gnu
984 www-gnu = http://www.gnu.org
986 upload_dest_dir_ ?= $(PACKAGE)
987 emit_upload_commands:
988 @echo =====================================
989 @echo =====================================
990 @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
991 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
992 @echo " $(rel-files)"
993 @echo '# send the ~/announce-$(my_distdir) e-mail'
994 @echo =====================================
995 @echo =====================================
997 noteworthy = * Noteworthy changes in release ?.? (????-??-??) [?]
998 define emit-commit-log
999 printf '%s\n' 'post-release administrivia' '' \
1000 '* NEWS: Add header line for next release.' \
1001 '* .prev-version: Record previous version.' \
1002 '* cfg.mk (old_NEWS_hash): Auto-update.'
1003 endef
1005 .PHONY: no-submodule-changes
1006 no-submodule-changes:
1007 if test -d $(srcdir)/.git; then \
1008 diff=$$(cd $(srcdir) && git submodule -q foreach \
1009 git diff-index --name-only HEAD) \
1010 || exit 1; \
1011 case $$diff in '') ;; \
1012 *) echo '$(ME): submodule files are locally modified:'; \
1013 echo "$$diff"; exit 1;; esac; \
1014 else \
1015 : ; \
1018 .PHONY: alpha beta stable
1019 ALL_RECURSIVE_TARGETS += alpha beta stable
1020 alpha beta stable: $(local-check) writable-files no-submodule-changes
1021 test $@ = stable \
1022 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1023 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1024 || :
1025 $(MAKE) vc-diff-check
1026 $(MAKE) news-check
1027 $(MAKE) distcheck
1028 $(MAKE) dist XZ_OPT=-9ev
1029 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1030 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1032 # Override this in cfg.mk if you follow different procedures.
1033 release-prep-hook ?= release-prep
1035 .PHONY: release-prep
1036 release-prep:
1037 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1038 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1039 $(MAKE) -s announcement > ~/announce-$(my_distdir)
1040 if test -d $(release_archive_dir); then \
1041 ln $(rel-files) $(release_archive_dir); \
1042 chmod a-w $(rel-files); \
1044 echo $(VERSION) > $(prev_version_file)
1045 $(MAKE) update-NEWS-hash
1046 perl -pi -e '$$. == 3 and print "$(noteworthy)\n\n\n"' NEWS
1047 $(emit-commit-log) > .ci-msg
1048 $(VC) commit -F .ci-msg -a
1049 rm .ci-msg
1051 .PHONY: web-manual
1052 web-manual:
1053 @test -z "$(manual_title)" \
1054 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1055 @cd '$(srcdir)/doc'; \
1056 $(SHELL) ../build-aux/gendocs.sh -o '$(abs_builddir)/doc/manual' \
1057 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1058 "$(PACKAGE_NAME) - $(manual_title)"
1059 @echo " *** Upload the doc/manual directory to web-cvs."
1061 # Code Coverage
1063 init-coverage:
1064 $(MAKE) $(AM_MAKEFLAGS) clean
1065 lcov --directory . --zerocounters
1067 COVERAGE_CCOPTS ?= "-g --coverage"
1068 COVERAGE_OUT ?= doc/coverage
1070 build-coverage:
1071 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1072 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1073 mkdir -p $(COVERAGE_OUT)
1074 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1075 --capture
1077 gen-coverage:
1078 genhtml --output-directory $(COVERAGE_OUT) \
1079 $(COVERAGE_OUT)/$(PACKAGE).info \
1080 --highlight --frames --legend \
1081 --title "$(PACKAGE_NAME)"
1083 coverage: init-coverage build-coverage gen-coverage
1085 # Update gettext files.
1086 PACKAGE ?= $(shell basename $(PWD))
1087 PO_DOMAIN ?= $(PACKAGE)
1088 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1089 PODIR ?= po
1090 refresh-po:
1091 rm -f $(PODIR)/*.po && \
1092 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1093 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1094 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1095 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1096 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1098 INDENT_SOURCES ?= $(C_SOURCES)
1099 .PHONY: indent
1100 indent:
1101 indent $(INDENT_SOURCES)
1103 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1104 # put the assignments in this variable.
1105 update-copyright-env ?=
1107 # Run this rule once per year (usually early in January)
1108 # to update all FSF copyright year lists in your project.
1109 # If you have an additional project-specific rule,
1110 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1111 # By default, exclude all variants of COPYING; you can also
1112 # add exemptions (such as ChangeLog..* for rotated change logs)
1113 # in the file .x-update-copyright.
1114 .PHONY: update-copyright
1115 update-copyright:
1116 grep -l -w Copyright \
1117 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1118 | $(update-copyright-env) xargs $(build_aux)/$@